Skip to main content

Configuring S3 after an update

warning

On September 29, 2023, a major S3 update was released. Previously created users, method calls to the Swift API (old) and Object Storage API (old), etc., will stop working on October 5, 2027, at 11:00 (UTC+3). Some features will no longer be supported; for details, see the Unavailable features section.

We recommend using the S3 API. Update your storage settings in advance.

If you had buckets created before the S3 update, transfer them to a project to continue working with S3 in the control panel.

The most significant changes in storage operation are:

Migrate buckets to a project

Without transferring to a project, you will not be able to work with the storage in the control panel.

You can migrate your storage only once and as a whole (to one project). It is not possible to distribute old buckets across different projects. You will be able to create new buckets in different projects.

If you already have a project, you can migrate the buckets to it or create a new one.

  1. In the control panel, click Products in the top menu and select S3. When you open the section for the first time after September 29, 2023, the bucket transfer page will open.
  2. Select Use an existing project.
  3. Select the project to which you want to transfer the buckets and click Transfer.

Configure S3

  1. Configure storage access for users.
  2. Configure the bucket access policy.
  3. If you use the API or FTP, update the access keys and URL.
  4. If you use CDN, edit the CDN resource.
  5. Verify that you have replaced the domains with the new ones.
  6. Delete legacy storage users.

1. Configure storage access for users

S3 now supports user types and roles:

  • access to S3 through the control panel will be available to panel users whose role allows access to the entire account or the project to which the buckets were migrated;
  • API access is performed via service users instead of storage users (previously created in the S3 → Users section). Legacy users will continue to work and will be disabled later. Creating new users of this type is no longer allowed.

You can add new users in the following sections:

For users with the object_storage_user, s3.user, and s3.bucket.user roles, access is determined solely by the access policy — if it is not configured, the user will not have access to the bucket. For more information on how different storage roles work, see the Managing Access in S3 guide.

2. Configure the bucket access policy

You can create a bucket access policy in the control panel. To create an access policy via the API, refer to the AWS S3 documentation.

When configuring the policy, take into account access permissions within the role model; for more details, see the Managing Access in S3 guide.

For more information on how access policies work, see the Bucket Policy section.

3. Update access keys and URLs

For more information on authorization, see the S3 API documentation.

  1. Issue an S3 key to the service user. You can also issue a key via the IAM API.

  2. In your requests, replace the URL and use the key for authentication according to the new scheme:

    • AWS_ACCESS_KEY_ID is the value of the Access key field from the S3 key;
    • AWS_SECRET_KEY is the value of the Secret key field from the S3 key;
    • URL is s3.<pool>.storage.selcloud.ru, where <pool> is the pool where S3 is located (for example, ru-1).

4. Modify CDN resource

If you use S3 as a CDN content source, modify the CDN resource.

  1. In the control panel, on the top menu, click Products and select CDN.
  2. In the CDN Resources section, open the CDN resource page → the Origin tab.
  3. In the Domain field, replace the specified domain with a public bucket domain like <uuid>.selstorage.ru.
  4. In the Hostname block, in the Hostname for origin requests field, specify the public bucket domain without the protocol and port. Port 80 is used by default.

5. Check domains

Make sure you are using the new domains everywhere.

Learn more about domains in the Domains in S3 guide.

PurposeOld domainNew domain
Public access*****.selcdn.ru<uuid>.selstorage.ru
Swift APIapi.selcdn.ruswift.<pool>.storage.selcloud.ru
S3 API
  • s3.storage.selcloud.ru/<bucket_name> (Path-Style)
  • <bucket_name>.s3.storage.selcloud.ru (Virtual Hosted)
  • s3.<pool>.storage.selcloud.ru/<bucket_name> (Path-Style)
  • <bucket_name>.s3.<pool>.storage.selcloud.ru (Virtual Hosted)
FTPftp.selcdn.ruftp.<pool>.storage.selcloud.ru
Domain for DNS records*****.selcdn.ruaccess.<pool>.storage.selcloud.ru

6. Delete old storage users

  1. In the control panel, on the top menu, click Products and select S3.
  2. Go to the Control panel users section.
  3. In the user card, click → Delete.

Unavailable functionality

Calls to Swift API (old) and Object Storage API (old) methods will stop working on 10/05/2027 at 11:00 (UTC+3). Use alternative features in S3 API, Object Storage API, or the control panel.

Unavailable functionalityAlternative
AuthenticationAuthorization using v1 protocol (GET /auth/v1.0, headers X-Auth-User and X-Auth-Key) Use AWS Signature V4 or AWS Signature Version 2 signatures and S3 keys in the S3 API
Authorization using v2 protocol (POST /v2.0/tokens, passwordCredentials)
Traffic statisticsStatistics on the volume of uploaded and downloaded data at the account and container level, response headers X-Received-Bytes and X-Transfered-BytesGet log exports via the control panel or Object Storage API
Fields rx_bytes and tx_bytes in the JSON response when getting a list of containers
Managing HTTP headers of objects
  • Access-Control-Allow-Origin — allowed origin for cross-domain requests;
  • Access-Control-Max-Age — preflight request caching time;
  • Access-Control-Allow-Methods — allowed HTTP methods for CORS;
  • Access-Control-Allow-Credentials — permission to pass credentials;
  • Access-Control-Expose-Headers — headers accessible to the client;
  • Access-Control-Allow-Headers — allowed headers in the request;
  • Strict-Transport-Security — forced HTTPS usage for the container
Use CORS in the control panel or via the S3 API (Bucket CORS). CORS is configured at the bucket level
DomainsPublic account domain (*****.selcdn.ru) — domain with content cachingUse S3 API domains
Temporary download linksGeneration of temporary signed download links via HMAC-SHA1 (temp_url_sig, temp_url_expires, secret key via X-Account-Meta-Temp-URL-Key / X-Container-Meta-Temp-URL-Key) Use Presigned URLs in the S3 API, which uses a different signing mechanism (AWS Signature V4). Code using TempURL will need to be refactored
File query parametersQuery parameter ?filename=file_name — forces the browser to download the file instead of opening it (header Content-Disposition: attachment) ✗
XML response format when requesting a file list (?format=xml) ✗